"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fn = exports.handler = exports.builder = exports.desc = exports.command = void 0;
const compileFile_1 = require("../helpers/compileFile");
const compileFolder_1 = require("../helpers/compileFolder");
exports.command = "compile <path>";
exports.desc = "Compile formula file/directory <path> to regex";
const builder = (yargs) => yargs
    .options({
    dir: { type: "boolean" },
    out: { type: "string", choices: ["regexp", "js"], default: "regexp" },
})
    .positional("path", { type: "string", demandOption: true });
exports.builder = builder;
const handler = (argv) => __awaiter(void 0, void 0, void 0, function* () {
    const { path: _path, dir, out } = argv;
    yield (0, exports.fn)(_path, dir !== null && dir !== void 0 ? dir : false, (out !== null && out !== void 0 ? out : "regexp"));
    process.stdout.write("> FINISHED");
    process.exit(0);
});
exports.handler = handler;
const fn = (path, isDir, out) => __awaiter(void 0, void 0, void 0, function* () {
    // Whole directory
    if (isDir) {
        yield (0, compileFolder_1.compileFolder)(path, out);
    }
    // One file
    else {
        yield (0, compileFile_1.compileFile)(path, out);
    }
});
exports.fn = fn;
