"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fn = exports.handler = exports.builder = exports.desc = exports.command = void 0;
const readFile_1 = require("../helpers/readFile");
const testString_1 = require("../helpers/testString");
const chalk_1 = __importDefault(require("chalk"));
exports.command = 'test <path>';
exports.desc = 'Run testing of formula in file/directory <path>';
const builder = (yargs) => yargs
    .positional('path', { type: 'string', demandOption: true });
exports.builder = builder;
const handler = (argv) => __awaiter(void 0, void 0, void 0, function* () {
    const { path: _path } = argv;
    yield (0, exports.fn)(_path);
    process.exit(0);
});
exports.handler = handler;
const fn = (path) => __awaiter(void 0, void 0, void 0, function* () {
    const formula = yield (0, readFile_1.readFile)(path);
    const testResults = (0, testString_1.testString)(formula);
    const textSuccess = chalk_1.default.green;
    const textError = chalk_1.default.red;
    // Print test results
    console.log(`[${path}]`);
    for (const testResult of testResults) {
        const message = `${testResult.isSuccess ? '✓' : '✖'} Test ${testResult.number}: ${testResult.value}`;
        console.log(' '.repeat(4) + (testResult.isSuccess
            ? textSuccess(message)
            : textError(message)));
    }
});
exports.fn = fn;
