"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compileFile = void 0;
const path_1 = __importDefault(require("path"));
const writeFile_1 = require("./writeFile");
const readFile_1 = require("./readFile");
const compileString_1 = require("./compileString");
/**
 * Compile .formula file
 * @param filePath path to filee
 */
const compileFile = (filePath, to = "regexp") => __awaiter(void 0, void 0, void 0, function* () {
    const baseName = path_1.default.basename(filePath, ".formula");
    const content = yield (0, readFile_1.readFile)(filePath);
    const { result } = to === "regexp" ? (0, compileString_1.compileToRegexp)(content) : (0, compileString_1.compileToJs)(content, baseName);
    yield (0, writeFile_1.writeFile)("./dist/" + baseName + (to === "regexp" ? ".txt" : ".js"), result);
});
exports.compileFile = compileFile;
