"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compileFolder = void 0;
const fs_1 = __importDefault(require("fs"));
const compileFile_1 = require("./compileFile");
/**
 * Compile folder with .formula files
 * @param dirPath path to folder
 */
const compileFolder = (dirPath, to = "regexp") => __awaiter(void 0, void 0, void 0, function* () {
    const files = yield fs_1.default.promises.readdir(dirPath);
    // Create /dist
    if (!fs_1.default.existsSync("./dist")) {
        yield fs_1.default.promises.mkdir("./dist");
    }
    // Compile files to /dist
    for (const file of files) {
        if (file.endsWith(".formula")) {
            yield (0, compileFile_1.compileFile)(dirPath + "/" + file, to);
        }
    }
});
exports.compileFolder = compileFolder;
