import type { StatementContext } from "@datasco/formula";
export declare type CompileOutput = "js" | "regexp";
export declare type CompileResult = {
    type: CompileOutput;
    result: string;
    context: StatementContext;
};
/**
 * Compile formula to RegExp text
 * @param formula formula code
 * @returns result of compilation
 */
export declare const compileToRegexp: (formula: string) => CompileResult;
/**
 * Compile formula to JS code
 * @param formula formula code
 * @returns result of compilation
 */
export declare const compileToJs: (formula: string, exportAs?: string) => CompileResult;
