"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.testString = void 0;
const compileString_1 = require("./compileString");
const testString = (formula) => {
    const { result, context } = (0, compileString_1.compileToRegexp)(formula);
    // Loop tests
    const testResults = [];
    let testNumber = 1;
    for (const test of context.test) {
        const testResult = new RegExp(result).test(test.value);
        testResults.push({
            isSuccess: testResult,
            number: testNumber,
            value: test.value,
        });
        testNumber++;
    }
    return testResults;
};
exports.testString = testString;
