"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const compileParams_1 = __importDefault(require("../../helpers/compileParams"));
const IParentStatement_1 = __importDefault(require("../IParentStatement"));
const StatementType_1 = __importDefault(require("../StatementType"));
class GroupStatement extends IParentStatement_1.default {
    constructor(children, params, named) {
        super(StatementType_1.default.Group, children);
        this.params = params;
        this.named = named;
    }
    serialize(ctx) {
        let children = this.children.map(child => child.serialize(ctx)).join('');
        let result = this.named === null
            ? `(?:${children})` // Group uncaptured (named=null)
            : this.named === undefined
                ? `(${children})` // Group captured (named=undefined)
                : `(?<${this.named}>${children})`; // Group captured, named
        return (0, compileParams_1.default)(result, this.params);
    }
}
exports.default = GroupStatement;
