"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const StatementType_1 = __importDefault(require("../StatementType"));
class IfElseStatement {
    constructor(condition, branchIf, branchElse) {
        this.type = StatementType_1.default.Condition;
        this.condition = condition;
        this.branchIf = branchIf;
        this.branchElse = branchElse;
    }
    serialize(ctx) {
        let condition = this.condition.map(child => child.serialize(ctx)).join('');
        let childrenIf = this.branchIf.map(child => child.serialize(ctx)).join('');
        let childrenElse = this.branchElse.map(child => child.serialize(ctx)).join('');
        return `(?(?=${condition})(${childrenIf}${childrenElse ? ')|(' + childrenElse : ''}))`;
    }
}
exports.default = IfElseStatement;
